#include "cell.h"
#include <stdio.h>

// Constructor. 
Cell::Cell()
{
}

Cell::~Cell()
{
	delete[] m_blnPossibles;
}

void Cell::SetValue(int intValue)
{
	m_intValue = intValue;
}

int Cell::GetValue()
{
	return m_intValue;
}

void Cell::SetSquareIndex(int intValue)
{
	m_intSquareIndex = intValue;
}

int Cell::GetSquareIndex()
{
	return m_intSquareIndex;
}

void Cell::SetRowIndex(int intValue)
{
	m_intRowIndex = intValue;
}

int Cell::GetRowIndex()
{
	return m_intRowIndex;
}

void Cell::SetColumnIndex(int intValue)
{
	m_intColumnIndex = intValue;
}

int Cell::GetColumnIndex()
{
	return m_intColumnIndex;
}

bool* Cell::GetPossibleValues()
{
	return m_blnPossibles;
}

int Cell::GetNumberOfPossibles()
{
	return m_intPossibleValueCount;
}

void Cell::SetGridsize(int intGridsize)
{
	m_intGridSize = intGridsize;
}

void Cell::SetPossibleValue(int intValue, bool blnPossible)
{
	int intLastPossibleFound = 0;

	// Set the flag to indicate if the value is a possible for this cell
	m_blnPossibles[intValue - 1] = blnPossible;

	// Recalculate the number of possibles
	m_intPossibleValueCount = 0;
	for(int i=0; i<m_intGridSize; i++)
	{
		if(m_blnPossibles[i] == true)
		{
			m_intPossibleValueCount++;
			intLastPossibleFound = i;
		}
	}

	// Validate if only one possible remains and if so set the cell value
	if(m_intPossibleValueCount == 1)
		m_intValue = intLastPossibleFound + 1;
		
}

void Cell::Reset()
{
	// Initialise
	m_intValue = 0;
	m_intPossibleValueCount = m_intGridSize;
	m_intSquareIndex = 0;
	m_blnPossibles = new bool[m_intGridSize];
	for(int i=0; i<m_intGridSize; i++)
		m_blnPossibles[i] = true;
}

void Cell::Initialise(int intGridsize)
{
	// Initialise
	m_intGridSize = intGridsize;
	Reset();
}

void Cell::Print()
{
	if(m_intValue > 0)
	{
		// Output the Value
		printf("Cell value: %i\n", m_intValue);
	}
	else
	{
		// Output each possible value
		printf("Possible values: ");
		for(int i=0; i<m_intGridSize; i++)
			if(m_blnPossibles[i] == true)
				printf("%i ", i+1);

		printf("\n");
	}


}
