#include "gridentity.h"
#include <stdio.h>

// Constructor. 
GridEntity::GridEntity()
{
	m_intIndex = -1;
	m_intCellCount = 0;
}

// Destructor
GridEntity::~GridEntity()
{
	delete[] m_intCells;
}

void GridEntity::Initialise(int intGridsize)
{
	m_intGridsize = intGridsize;
	m_intCells = new int[intGridsize];
}

void GridEntity::SetIndex(int intValue)
{
	m_intIndex = intValue;
}

int GridEntity::GetIndex()
{
	return m_intIndex;
}

int* GridEntity::GetCells()
{
	return m_intCells;
}

void GridEntity::SetGridsize(int intGridsize)
{
	m_intGridsize = intGridsize;
}

void GridEntity::AddCell(int intCellIndex)
{
	if(m_intCellCount < m_intGridsize)
	{
		m_intCells[m_intCellCount] = intCellIndex;
		m_intCellCount++;
	}
}

int GridEntity::GetCellIndex(int intCellNo)
{
	return m_intCells[intCellNo];
}

void GridEntity::Print()
{
	printf("Cell Count %i\n", m_intCellCount);
	printf("Cell Indexes: ");
	for(int i=0; i<m_intGridsize; i++)
		printf("%i ", m_intCells[i]);
	printf("\n");
}
