#include "helper.h"
#include <stdlib.h>
#include <stdio.h>

int GetSquareNumber(int intCellIndex, int intGridSize)
{
	// Calculate the Square Number for a cell
	int intRowNo = ((intCellIndex - (intCellIndex%intGridSize)) / intGridSize);
	int intColNo = (intCellIndex%intGridSize);
	int intTemp = abs((int)sqrt(intGridSize));
	int intSquareNo = ((intRowNo/intTemp)*intTemp)+(intColNo/intTemp);

	return intSquareNo;
}

int GetColumnNumber(int intCellIndex, int intGridSize)
{
	// Calculate the Column Number for a cell
	return (intCellIndex%intGridSize);
}

int GetRowNumber(int intCellIndex, int intGridSize)
{
	// Calculate the Square Number for a cell
	return ((intCellIndex - (intCellIndex%intGridSize)) / intGridSize);
}

int* GetColumnsInSquare(int intCellIndex, int intGridSize, bool blnExcludeCurrent = true)
{
	// Find the column numbers of each column in the current square
	// (optionally excluding current one).

	int intMaxCols = abs((int)sqrt(intGridSize));
	if(blnExcludeCurrent)
		intMaxCols--;

	int* intOtherColumns;
	intOtherColumns = new int[intMaxCols];

	int intColNo = GetColumnNumber(intCellIndex, intGridSize);
	int intSquareNo = GetSquareNumber(intCellIndex, intGridSize);
	int intFirstColInSquare = (intSquareNo % abs((int)sqrt(intGridSize))) * abs((int)sqrt(intGridSize));

	int intCount = 0;
	for(int i=intFirstColInSquare; i<intFirstColInSquare+abs((int)sqrt(intGridSize)); i++)
		if(!blnExcludeCurrent || i != intColNo)
			intOtherColumns[intCount++] = i;

	return intOtherColumns;
}

int* GetRowsInSquare(int intCellIndex, int intGridSize, bool blnExcludeCurrent = true)
{
	// Find the row numbers of each row in the current square
	// (optionally excluding current one).
	int intMaxRows = abs((int)sqrt(intGridSize));
	if(blnExcludeCurrent)
		intMaxRows--;

	int* intOtherRows;
	intOtherRows = new int[intMaxRows];

	int intRowNo = GetRowNumber(intCellIndex, intGridSize);
	int intSquareNo = GetSquareNumber(intCellIndex, intGridSize);
	int intFirstRowInSquare = ((intSquareNo / intGridSize) * abs((int)sqrt(intGridSize)));

	int intCount = 0;
	for(int i=intFirstRowInSquare; i<intFirstRowInSquare+abs((int)sqrt(intGridSize)); i++)
		if(!blnExcludeCurrent || i != intRowNo)
			intOtherRows[intCount++] = i;

	return intOtherRows;

}

int GetCellIndex(int intRow, int intCol, int intGridSize)
{
	return (intRow * intGridSize) + intCol;
}

unsigned int GenerateRandomInteger(unsigned int intMax)
{
	return random() % intMax;
}

bool GenerateRandomBoolean()
{
	unsigned int intRand = GenerateRandomInteger(2);
	if(intRand == 0)
		return false;
	else
		return true;
}
